const mongoose = require('mongoose');
const config = require('../config/database');

const FollowUpTypeSchema = mongoose.Schema({
  followUpType: String,
  hasDueDate: String,
  canDelete: { type: Boolean, default: true },
  createdBy: { type: String, required: true },
  createdAt: {
    type: Date,
    default: Date.now()
  },
  updatedAt: { type: Date }
});

const FollowUpType = (module.exports = mongoose.model(
  'followUpType',
  FollowUpTypeSchema
));

module.exports.addFollowUpType = (newFollowUpType, callback) => {
  newFollowUpType.save(callback);
};

module.exports.getFollowUpTypeByName = (followUpType, callback) => {
  FollowUpType.findOne({ followUpType: followUpType }, callback);
};

module.exports.getFollowUpTypes = callback => {
  FollowUpType.find(callback);
};

module.exports.deleteFollowUpType = (followuptype, callback) => {
  FollowUpType.deleteOne({ followUpType: followuptype }, callback);
};
