const mongoose = require('mongoose');
const config = require('../config/database');

const OldPackageSchema = mongoose.Schema({
  packageName: { type: String, required: true },
  createdBy: { type: String, required: true },
  createdAt: {
    type: Date,
    default: Date.now()
  },
  updatedAt: { type: Date }
});

const Package = (module.exports = mongoose.model(
  'OldPackage',
  OldPackageSchema
));

module.exports.addPackage = (OldPackage, callback) => {
  OldPackage.save(callback);
};

module.exports.getPackageByName = (packageName, callback) => {
  Package.findOne({ packageName: packageName }, callback);
};

module.exports.getPackage = callback => {
  Package.find(callback);
};
