const mongoose = require('mongoose');
const config = require('../config/database');

const stateSchema = mongoose.Schema({
  stateName: { type: String, required: true },
  stateCode: { type: String, required: true },
  stateId: { type: String, required: true },
  cities: { type: Array, default: [] },
  allotedBy: { type: String }
});

const State = (module.exports = mongoose.model('state', stateSchema));

module.exports.addState = (newState, callback) => {
  newState.save(callback);
};

module.exports.getStateByStatecode = (statecode, callback) => {
  State.findOne({ stateCode: statecode }, callback);
};

module.exports.getStatebyName = (state, callback) => {
  State.findOne({ stateName: state }, callback);
};

module.exports.getStateById = (id, callback) => {
  State.findOne({ _id: id }, callback);
};

module.exports.getAllStates = callback => {
  State.find(callback);
};
