const express = require('express');
const router = express.Router();
const config = require('../config/database');
const Office = require('../models/office');
const passport = require('passport');

router.post(
  '/create-office',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let office = new Office({
      createdBy: req.body.createdBy,
      officeName: req.body.officeName,
      officeCity: req.body.officeCity,
      officeAdmin: req.body.officeAdmin,
      officeType: req.body.officeType,
      officeAddress: req.body.officeAddress,
      officeContact: req.body.officeContact,
      officePackage: req.body.officePackage,
      officePercentage: req.body.officePercentage
    });

    Office.addOffice(office, (err, newOffice) => {
      if (err) {
        res.status(200).json({ success: false, msg: '', err: err });
      } else {
        res.status(200).json({
          success: true,
          msg: 'Office added successfully',
          office: newOffice
        });
      }
    });
  }
);

router.get(
  '/getAllOffice',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Office.getAllOffice((err, officeList) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch office list.',
          err: err
        });
      } else {
        res.status(200).json({
          success: true,
          msg: 'Office list fetched',
          officeList: officeList
        });
      }
    });
  }
);

router.post(
  '/getOfficeById',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Office.getOfficeById(req.body.officeId, (err, office) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch office details',
          err: err
        });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'office fetched', office: office });
      }
    });
  }
);

module.exports = router;
